require 'robut/plugin/giphy'
require 'webmock/test_unit'

module GiphyTestBase

  def setup
    @connection = Robut::ConnectionMock.new
    @presence = Robut::PresenceMock.new(@connection)
    @plugin = new_plugin(@presence)

    Robut::Plugin::Giphy.configure do |config|
      config.api_key = 'dc6zaTOxFJmzC'
      config.rating = 'pg'
    end

    stub_request(:any, "http://api.giphy.com/v1/gifs/random?api_key=dc6zaTOxFJmzC&tag=hjklxxxx&rating=pg")
      .to_return(status: 200, body: <<EOT)
{"data":[],"meta":{"status":200,"msg":"OK"}}
EOT

    stub_request(:any, "http://api.giphy.com/v1/gifs/random?api_key=your-mom&tag=american+psycho&rating=pg")
      .to_return(status: 500)
    
    stub_request(:any, "http://api.giphy.com/v1/gifs/random?api_key=dc6zaTOxFJmzC&tag=american+psycho&rating=pg")
      .to_return(status: 200, body: <<EOT)
{
    "data": {
        "type": "gif",
        "id": "Ggjwvmqktuvf2",
        "url": "http://giphy.com/gifs/american-psycho-christian-bale-Ggjwvmqktuvf2",
        "image_original_url": "http://s3.amazonaws.com/giphygifs/media/Ggjwvmqktuvf2/giphy.gif",
        "image_url": "http://s3.amazonaws.com/giphygifs/media/Ggjwvmqktuvf2/giphy.gif",
        "image_mp4_url": "http://s3.amazonaws.com/giphygifs/media/Ggjwvmqktuvf2/giphy.mp4",
        "image_frames": "11",
        "image_width": "500",
        "image_height": "256",
        "fixed_height_downsampled_url": "http://s3.amazonaws.com/giphygifs/media/Ggjwvmqktuvf2/200_d.gif",
        "fixed_height_downsampled_width": "391",
        "fixed_height_downsampled_height": "200",
        "fixed_width_downsampled_url": "http://s3.amazonaws.com/giphygifs/media/Ggjwvmqktuvf2/200w_d.gif",
        "fixed_width_downsampled_width": "200",
        "fixed_width_downsampled_height": "102",
        "fixed_height_small_url": "http://s3.amazonaws.com/giphygifs/media/Ggjwvmqktuvf2/100.gif",
        "fixed_height_small_still_url": "http://s3.amazonaws.com/giphygifs/media/Ggjwvmqktuvf2/100_s.gif",
        "fixed_height_small_width": "195",
        "fixed_height_small_height": "100",
        "fixed_width_small_url": "http://s3.amazonaws.com/giphygifs/media/Ggjwvmqktuvf2/100w.gif",
        "fixed_width_small_still_url": "http://s3.amazonaws.com/giphygifs/media/Ggjwvmqktuvf2/100w_s.gif",
        "fixed_width_small_width": "100",
        "fixed_width_small_height": "51"                 
    },
    "meta": {
        "status": 200,
        "msg": "OK"
    }
}
EOT
  end

end
